#ifndef _CONNTRACK_PROTO_ESP_H
#define _CONNTRACK_PROTO_ESP_H
#include <asm/byteorder.h>
#include <linux/timer.h>
#include <linux/list.h>
/* ESP PROTOCOL HEADER */

/* ESP Variate field */
#define ESP_PROTOCOL	(0x32)

/* ESP is a mess*/
struct esp_hdr {
	__u32	spi;
	__u32	seq;
};


/* this is part of ip_conntrack */
struct ip_ct_esp {
	unsigned int stream_timeout;
	unsigned int timeout;
};

/* this is part of ip_conntrack_expect */
struct ip_ct_esp_expect {
	struct ip_ct_esp_spi *spi_orig, *spi_reply;
};

#ifdef __KERNEL__
struct ip_conntrack_expect;


/* conntrack private data */
struct ip_ct_esp_master
{
	unsigned int sip;
	unsigned int dip;
	unsigned int spi_local;
	unsigned int spi_remote;
	unsigned int dir;
};

/* structure for original ip <-> reply spi to find correct ip */
struct ip_ct_esp_spi 
{
	struct list_head list;
	struct timer_list timeout;	/* Timer for list destroying */
    struct ip_ct_esp_master esp_master;
	//struct ip_conntrack_tuple esp_master;
};

unsigned int esp_packet_in(const struct iphdr *iph, u_int32_t *sip, u_int32_t *dip);
unsigned int esp_packet_out(const struct iphdr *iph, unsigned int len,enum ip_conntrack_info ctinfo );


/* add new tuple->key_reply pair to keymap */
int ip_ct_esp_spi_add(struct ip_conntrack_expect *exp, struct ip_conntrack_tuple *t, int reply);

/* change an existing keymap entry */
void ip_ct_esp_spi_change(struct ip_ct_esp_spi *spi, struct ip_conntrack_tuple *t);

/* delete keymap entries */
void ip_ct_esp_spi_destroy(struct ip_conntrack_expect *exp);


#endif /* __KERNEL__ */

#endif /* _CONNTRACK_PROTO_ESP_*/



