/*
 * Layer Two Tunnelling Protocol Daemon
 * Copyright (C) 1998 Adtran, Inc.
 *
 * Mark Spencer
 *
 * This software is distributed under the terms
 * of the GPL, which you should have received
 * along with this source.
 *
 * Misc stuff...
 */

#ifndef _MISC_H
#define _MISC_H

struct tunnel;
struct buffer
{
    int type;
    void *rstart;
    void *rend;
    void *start;
    int len;
    int maxlen;
#if 0
    unsigned int addr;
    int port;
#else
    struct sockaddr_in peer;
#endif
    struct tunnel *tunnel;      /* Who owns this packet, if it's a control */
    int retries;                /* Again, if a control packet, how many retries? */
};

struct ppp_opts
{
    char option[MAXSTRLEN];
    struct ppp_opts *next;
};

#define IPADDY(a) inet_ntoa(*((struct in_addr *)&(a)))

#define DEBUG c ? c->debug || t->debug : t->debug

#ifdef USE_SWAPS_INSTEAD
#define SWAPS(a) ((((a) & 0xFF) << 8 ) | (((a) >> 8) & 0xFF))
#ifdef htons
#undef htons
#endif
#ifdef ntohs
#undef htons
#endif
#define htons(a) SWAPS(a)
#define ntohs(a) SWAPS(a)
#endif

#define LOG_DEBUG 7
#define LOG_LOG   6
#define LOG_WARN  4
#define LOG_CRIT  2

//@@@ wnlee 2k2-10-12
#define LNS 	0
#define LAC 	1
#define BOTH	2
//@@@

#define halt() printf("Halted.\n") ; for(;;)

extern char hostname[];
extern void msg_log (int level, const char *fmt, ...);
extern struct buffer *new_buf (int);
extern void udppush_handler (int);
extern int addfcs (struct buffer *buf);
extern inline void swaps (void *, int);
extern void do_packet_dump (struct buffer *);
extern void status (const char *fmt, ...);
extern void status_handler (int sig);
extern int getPtyMaster (char *a, char *b);
extern void do_control (void);
extern void recycle_buf (struct buffer *);
extern void safe_copy (char *, char *, int);
extern void opt_destroy (struct ppp_opts *);
//@@@ib wnlee 2k2/10/26
extern int write_csf(int ,int, char *, int, int,int);
int modify_ui_files (int status1,int ui_no,char *remote_ip, int tid,
                     int cid, int action);
extern int write_tid(int, int);
extern int unlink_ui_files(void);
extern int dialondemand(char* interface);
//@@@ie
extern struct ppp_opts *add_opt (struct ppp_opts *, char *, ...);
#endif
